package milab;

import javax.xml.bind.*;
import org.w3c.dom.*;
import java.io.File;
import java.io.FileOutputStream;
import java.io.StringWriter;
import java.io.IOException;

public class JAXBMarshaller {
	
	public void generateXMLDocument(String filePath, Object pObject, String contextPackage) {

		try {

			File xmlDocument = new File(filePath);
			JAXBContext jaxbContext = JAXBContext.newInstance(contextPackage);
			Marshaller marshaller = jaxbContext.createMarshaller();
			marshaller.setProperty("jaxb.formatted.output", new Boolean(true));	
			marshaller.marshal(pObject, new FileOutputStream(xmlDocument));

		} catch (IOException e) {
			
			System.out.println(e.toString());
		
		} catch (JAXBException e) {
			
			System.out.println(e.toString());
		
		}
		
	}

	public String generateXMLString(String encoding, Object pObject, String contextPackage) {

		String ret = "";
		
		try {

			JAXBContext jaxbContext = JAXBContext.newInstance(contextPackage);
			Marshaller marshaller = jaxbContext.createMarshaller();
			marshaller.setProperty("jaxb.formatted.output", new Boolean(true));
			marshaller.setProperty(Marshaller.JAXB_ENCODING, encoding);
			java.io.StringWriter sw = new StringWriter();			
			marshaller.marshal(pObject, sw);
			ret = sw.toString();

		} catch (JAXBException e) {
			
			System.out.println(e.toString());
		
		}
		
		return ret;
		
	}
	
}